; FASM source code
; http://flatassembler.net/
org 100h
  ; show info
  mov  ah, 0009h
  mov  dx, _info
  int  021h
  ; wait for key
  xor  ax, ax
  int  016h
  ; Esc - exit
  cmp  al, 01Bh
  jz   @quit
  ; Backspace - rollback
  sub  al, 008h
  mov  [_inst], al
  ; open file for read-write
  mov  ax, 03D02h
  mov  dx, _file
  int  021h
  jnc  @f
  ; show error message
  mov  ah, 009h
  mov  dx, _msg1
  int  21h
  jmp  @quit
  @@:
  ; file handle
  mov  bx, ax
  ; check file size
  mov  ax, 04202h
  xor  cx, cx
  xor  dx, dx
  int  21h
  ; dx:ax - file size
  sub  ax, [_size]
  sub  dx, [_size+2]
  or   ax, dx
  jz   @f
  ; show error message
  mov  ah, 009h
  mov  dx, _msg2
  int  21h
  jmp  @close
  @@:
  ; save date/time
  mov  ax, 05700h
  int  021h
  mov  [_time], cx
  mov  [_date], dx
  ; apply fixes
  mov  di, LEN_data
  mov  si, _data
  @loop:
    ; offset
    cld
    lodsw
    mov  dx, ax
    lodsw
    mov  cx, ax
    ; seek to file position
    mov  ax, 04200h
    int  021h
    ; byte to patch
    mov  dx, si
    inc  si
    inc  si
    ; install or rollback
    cmp  [_inst], 0
    jz   @f
    inc  dx
    @@:
    ; write data
    mov  ah, 040h
    mov  cx, 001h
    int  021h
    dec  di
  jnz @loop
  ; restore date/time
  mov  cx, [_time]
  mov  dx, [_date]
  mov  ax, 05701h
  int  021h
  ; show message
  mov  ah, 009h
  mov  dx, _msg3
  int  21h
@close:
  ; close file
  mov  ah, 03Eh
  int  021h
@quit:
  ; exit to DOS
  mov  ax, 04C00h
  int  021h

_file db 'DOOM2D.EXE',0
_size: dd 139835d
_data:
; flg always 1
dd 0000A8B1h
db 02Dh, 000h
; open() flags: READ|WRITE -> READ only
dd 00016178h
db 002h, 000h
LEN_data = ($ - _data) / 6
_info:
db 'Doom2D Fatal Error Fix',13,10
db '~~~~~~~~~~~~~~~~~~~~~~',13,10
db '(c) -=CHE@TER=- 2004,2013,2014,2019',13,10
db 'web: http://ctpax-cheater.losthost.org/htmldocs/doom2dsg.htm',13,10
db 'mailto: _CTPAX_@MAIL.RU',13,10
db 13,10
db ' ࠢ ⪫砥   Doom2D V1.30 :',13,10
db 13,10
db 'FATAL ERROR:',13,10
db ' ⠭ ',13,10
db 13,10
db '  ࠢ ⮫쪮 "DOOM2D.EXE",  䠩 "DOOM2D.WAD" ⥯ ',13,10
db ' -      CD/DVD/BD   ᪠ 㤠.',13,10
db 13,10
db ' : 22:00 26.06.2004',13,10
db '몠쭠 প: Roxette - Listen To Your Heart',13,10
db 13,10
db ' : 04:00 16.01.2013 (: 21:12 28.10.2013; 13:40 28.08.2014)',13,10
db '몠쭠 প: 䨭 - ᭠',13,10
db 13,10
db '୮: Prikol Software, Grom PE  ᥬ Doom2D.org ᮮ.',13,10
db 13,10
db 'Esc - 室; Backspace - ⪠;  㣠  - ⠭ ࠢ.',13,10
db 13,10,'$'
_msg1 db '訡:   䠩 "DOOM2D.EXE"  .',13,10,'$'
_msg2 db '訡:  ࠧ -  䠩  "DOOM2D.EXE" V1.30.',13,10,'$'
_msg3 db '⮢.',13,10,'$'
_time rw 1
_date rw 1
_inst rb 1
